target-i386: Use mulu2 and muls2
[qemu/pbrook.git] / tests / qemu-iotests / common.rc
blobe522d617aa20782a35f1616756c6a4997be3a4a2
1 #!/bin/bash
3 # Copyright (C) 2009 Red Hat, Inc.
4 # Copyright (c) 2000-2006 Silicon Graphics, Inc. All Rights Reserved.
6 # This program is free software; you can redistribute it and/or modify
7 # it under the terms of the GNU General Public License as published by
8 # the Free Software Foundation; either version 2 of the License, or
9 # (at your option) any later version.
11 # This program is distributed in the hope that it will be useful,
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14 # GNU General Public License for more details.
16 # You should have received a copy of the GNU General Public License
17 # along with this program. If not, see <http://www.gnu.org/licenses/>.
20 dd()
22 if [ "$HOSTOS" == "Linux" ]
23 then
24 command dd --help | grep noxfer > /dev/null 2>&1
26 if [ "$?" -eq 0 ]
27 then
28 command dd status=noxfer $@
29 else
30 command dd $@
32 else
33 command dd $@
37 # we need common.config
38 if [ "$iam" != "check" ]
39 then
40 if ! . ./common.config
41 then
42 echo "$iam: failed to source common.config"
43 exit 1
47 # make sure we have a standard umask
48 umask 022
50 if [ "$IMGPROTO" = "file" ]; then
51 TEST_IMG=$TEST_DIR/t.$IMGFMT
52 elif [ "$IMGPROTO" = "nbd" ]; then
53 TEST_IMG_FILE=$TEST_DIR/t.$IMGFMT
54 TEST_IMG="nbd:127.0.0.1:10810"
55 else
56 TEST_IMG=$IMGPROTO:$TEST_DIR/t.$IMGFMT
59 function valgrind_qemu_io()
61 valgrind --log-file=/tmp/$$.valgrind --error-exitcode=99 $REAL_QEMU_IO "$@"
62 if [ $? != 0 ]; then
63 cat /tmp/$$.valgrind
65 rm -f /tmp/$$.valgrind
69 _optstr_add()
71 if [ -n "$1" ]; then
72 echo "$1,$2"
73 else
74 echo "$2"
78 _set_default_imgopts()
80 if [ "$IMGFMT" == "qcow2" ] && ! (echo "$IMGOPTS" | grep "compat=" > /dev/null); then
81 IMGOPTS=$(_optstr_add "$IMGOPTS" "compat=1.1")
85 _make_test_img()
87 # extra qemu-img options can be added by tests
88 # at least one argument (the image size) needs to be added
89 local extra_img_options=""
90 local image_size=$*
91 local optstr=""
92 local img_name=""
94 if [ -n "$TEST_IMG_FILE" ]; then
95 img_name=$TEST_IMG_FILE
96 else
97 img_name=$TEST_IMG
100 if [ -n "$IMGOPTS" ]; then
101 optstr=$(_optstr_add "$optstr" "$IMGOPTS")
104 if [ "$1" = "-b" ]; then
105 extra_img_options="$1 $2"
106 image_size=$3
108 if [ \( "$IMGFMT" = "qcow2" -o "$IMGFMT" = "qed" \) -a -n "$CLUSTER_SIZE" ]; then
109 optstr=$(_optstr_add "$optstr" "cluster_size=$CLUSTER_SIZE")
112 if [ -n "$optstr" ]; then
113 extra_img_options="-o $optstr $extra_img_options"
116 # XXX(hch): have global image options?
117 $QEMU_IMG create -f $IMGFMT $extra_img_options $img_name $image_size | \
118 sed -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
119 -e "s#$TEST_DIR#TEST_DIR#g" \
120 -e "s#$IMGFMT#IMGFMT#g" \
121 -e "s# encryption=off##g" \
122 -e "s# cluster_size=[0-9]\\+##g" \
123 -e "s# table_size=[0-9]\\+##g" \
124 -e "s# compat='[^']*'##g" \
125 -e "s# compat6=\\(on\\|off\\)##g" \
126 -e "s# static=\\(on\\|off\\)##g" \
127 -e "s# lazy_refcounts=\\(on\\|off\\)##g"
129 # Start an NBD server on the image file, which is what we'll be talking to
130 if [ $IMGPROTO = "nbd" ]; then
131 eval "$QEMU_NBD -v -t -b 127.0.0.1 -p 10810 $TEST_IMG_FILE &"
132 QEMU_NBD_PID=$!
133 sleep 1 # FIXME: qemu-nbd needs to be listening before we continue
137 _cleanup_test_img()
139 case "$IMGPROTO" in
141 nbd)
142 kill $QEMU_NBD_PID
143 rm -f $TEST_IMG_FILE
145 file)
146 rm -f $TEST_DIR/t.$IMGFMT
147 rm -f $TEST_DIR/t.$IMGFMT.orig
148 rm -f $TEST_DIR/t.$IMGFMT.base
151 rbd)
152 rbd rm $TEST_DIR/t.$IMGFMT > /dev/null
155 sheepdog)
156 collie vdi delete $TEST_DIR/t.$IMGFMT
159 esac
162 _check_test_img()
164 $QEMU_IMG check "$@" -f $IMGFMT $TEST_IMG 2>&1 | \
165 sed -e '/allocated.*fragmented.*compressed clusters/d' \
166 -e 's/qemu-img: This image format does not support checks/No errors were found on the image./' \
167 -e '/Image end offset: [0-9]\+/d'
170 _img_info()
172 $QEMU_IMG info "$@" $TEST_IMG 2>&1 | \
173 sed -e "s#$IMGPROTO:$TEST_DIR#TEST_DIR#g" \
174 -e "s#$TEST_DIR#TEST_DIR#g" \
175 -e "s#$IMGFMT#IMGFMT#g" \
176 -e "/^disk size:/ D" \
177 -e "/actual-size/ D"
180 _get_pids_by_name()
182 if [ $# -ne 1 ]
183 then
184 echo "Usage: _get_pids_by_name process-name" 1>&2
185 exit 1
188 # Algorithm ... all ps(1) variants have a time of the form MM:SS or
189 # HH:MM:SS before the psargs field, use this as the search anchor.
191 # Matches with $1 (process-name) occur if the first psarg is $1
192 # or ends in /$1 ... the matching uses sed's regular expressions,
193 # so passing a regex into $1 will work.
195 ps $PS_ALL_FLAGS \
196 | sed -n \
197 -e 's/$/ /' \
198 -e 's/[ ][ ]*/ /g' \
199 -e 's/^ //' \
200 -e 's/^[^ ]* //' \
201 -e "/[0-9]:[0-9][0-9] *[^ ]*\/$1 /s/ .*//p" \
202 -e "/[0-9]:[0-9][0-9] *$1 /s/ .*//p"
205 # fqdn for localhost
207 _get_fqdn()
209 host=`hostname`
210 $NSLOOKUP_PROG $host | $AWK_PROG '{ if ($1 == "Name:") print $2 }'
213 # check if run as root
215 _need_to_be_root()
217 id=`id | $SED_PROG -e 's/(.*//' -e 's/.*=//'`
218 if [ "$id" -ne 0 ]
219 then
220 echo "Arrgh ... you need to be root (not uid=$id) to run this test"
221 exit 1
226 # Do a command, log it to $seq.full, optionally test return status
227 # and die if command fails. If called with one argument _do executes the
228 # command, logs it, and returns its exit status. With two arguments _do
229 # first prints the message passed in the first argument, and then "done"
230 # or "fail" depending on the return status of the command passed in the
231 # second argument. If the command fails and the variable _do_die_on_error
232 # is set to "always" or the two argument form is used and _do_die_on_error
233 # is set to "message_only" _do will print an error message to
234 # $seq.out and exit.
236 _do()
238 if [ $# -eq 1 ]; then
239 _cmd=$1
240 elif [ $# -eq 2 ]; then
241 _note=$1
242 _cmd=$2
243 echo -n "$_note... "
244 else
245 echo "Usage: _do [note] cmd" 1>&2
246 status=1; exit
249 (eval "echo '---' \"$_cmd\"") >>$here/$seq.full
250 (eval "$_cmd") >$tmp._out 2>&1; ret=$?
251 cat $tmp._out >>$here/$seq.full
252 if [ $# -eq 2 ]; then
253 if [ $ret -eq 0 ]; then
254 echo "done"
255 else
256 echo "fail"
259 if [ $ret -ne 0 ] \
260 && [ "$_do_die_on_error" = "always" \
261 -o \( $# -eq 2 -a "$_do_die_on_error" = "message_only" \) ]
262 then
263 [ $# -ne 2 ] && echo
264 eval "echo \"$_cmd\" failed \(returned $ret\): see $seq.full"
265 status=1; exit
268 return $ret
271 # bail out, setting up .notrun file
273 _notrun()
275 echo "$*" >$seq.notrun
276 echo "$seq not run: $*"
277 status=0
278 exit
281 # just plain bail out
283 _fail()
285 echo "$*" | tee -a $here/$seq.full
286 echo "(see $seq.full for details)"
287 status=1
288 exit 1
291 # tests whether $IMGFMT is one of the supported image formats for a test
293 _supported_fmt()
295 for f; do
296 if [ "$f" = "$IMGFMT" -o "$f" = "generic" ]; then
297 return
299 done
301 _notrun "not suitable for this image format: $IMGFMT"
304 # tests whether $IMGPROTO is one of the supported image protocols for a test
306 _supported_proto()
308 for f; do
309 if [ "$f" = "$IMGPROTO" -o "$f" = "generic" ]; then
310 return
312 done
314 _notrun "not suitable for this image protocol: $IMGPROTO"
317 # tests whether the host OS is one of the supported OSes for a test
319 _supported_os()
321 for h
323 if [ "$h" = "$HOSTOS" ]
324 then
325 return
327 done
329 _notrun "not suitable for this OS: $HOSTOS"
332 _unsupported_qemu_io_options()
334 for bad_opt
336 for opt in $QEMU_IO_OPTIONS
338 if [ "$bad_opt" = "$opt" ]
339 then
340 _notrun "not suitable for qemu-io option: $bad_opt"
342 done
343 done
346 # this test requires that a specified command (executable) exists
348 _require_command()
350 [ -x "$1" ] || _notrun "$1 utility required, skipped this test"
353 _full_imgfmt_details()
355 if [ -n "$IMGOPTS" ]; then
356 echo "$IMGFMT ($IMGOPTS)"
357 else
358 echo "$IMGFMT"
362 _full_imgproto_details()
364 echo "$IMGPROTO"
367 _full_platform_details()
369 os=`uname -s`
370 host=`hostname -s`
371 kernel=`uname -r`
372 platform=`uname -m`
373 echo "$os/$platform $host $kernel"
376 _link_out_file()
378 if [ -z "$1" ]; then
379 echo Error must pass \$seq.
380 exit
382 rm -f $1
383 if [ "`uname`" == "IRIX64" ] || [ "`uname`" == "IRIX" ]; then
384 ln -s $1.irix $1
385 elif [ "`uname`" == "Linux" ]; then
386 ln -s $1.linux $1
387 else
388 echo Error test $seq does not run on the operating system: `uname`
389 exit
393 _die()
395 echo $@
396 exit 1
399 # make sure this script returns success
400 /bin/true